

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Forecast &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.Forecast</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Predict future weather using recent data.</span>

<span class="sd">usage: python Forecast.py [options] data_dir</span>
<span class="sd">options are:</span>
<span class="sd"> -h | --help  display this help</span>
<span class="sd">data_dir is the root directory of the weather data</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>
<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="kn">import</span> <span class="nn">DataStore</span>
<span class="kn">import</span> <span class="nn">Localisation</span>
<span class="kn">from</span> <span class="nn">TimeZone</span> <span class="kn">import</span> <span class="n">Local</span><span class="p">,</span> <span class="n">utc</span>
<span class="kn">import</span> <span class="nn">ZambrettiCore</span>

<div class="viewcode-block" id="ZambrettiCode"><a class="viewcode-back" href="../../api/pywws.Forecast.html#pywws.Forecast.ZambrettiCode">[docs]</a><span class="k">def</span> <span class="nf">ZambrettiCode</span><span class="p">(</span><span class="n">params</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">):</span>
    <span class="n">north</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;Zambretti&#39;</span><span class="p">,</span> <span class="s">&#39;north&#39;</span><span class="p">,</span> <span class="s">&#39;True&#39;</span><span class="p">))</span>
    <span class="n">baro_upper</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;Zambretti&#39;</span><span class="p">,</span> <span class="s">&#39;baro upper&#39;</span><span class="p">,</span> <span class="s">&#39;1050.0&#39;</span><span class="p">))</span>
    <span class="n">baro_lower</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;Zambretti&#39;</span><span class="p">,</span> <span class="s">&#39;baro lower&#39;</span><span class="p">,</span> <span class="s">&#39;950.0&#39;</span><span class="p">))</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;rel_pressure&#39;</span><span class="p">]:</span>
        <span class="k">return</span> <span class="s">&#39;&#39;</span>
    <span class="k">if</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;wind_ave&#39;</span><span class="p">]</span> <span class="ow">is</span> <span class="bp">None</span> <span class="ow">or</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;wind_ave&#39;</span><span class="p">]</span> <span class="o">&lt;</span> <span class="mf">0.3</span><span class="p">:</span>
        <span class="n">wind</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">wind</span> <span class="o">=</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;wind_dir&#39;</span><span class="p">]</span>
    <span class="k">if</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;pressure_trend&#39;</span><span class="p">]</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">trend</span> <span class="o">=</span> <span class="mf">0.0</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">trend</span> <span class="o">=</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;pressure_trend&#39;</span><span class="p">]</span> <span class="o">/</span> <span class="mf">3.0</span>
    <span class="k">return</span> <span class="n">ZambrettiCore</span><span class="o">.</span><span class="n">ZambrettiCode</span><span class="p">(</span>
        <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;rel_pressure&#39;</span><span class="p">],</span> <span class="n">hourly_data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">month</span><span class="p">,</span> <span class="n">wind</span><span class="p">,</span> <span class="n">trend</span><span class="p">,</span>
        <span class="n">north</span><span class="o">=</span><span class="n">north</span><span class="p">,</span> <span class="n">baro_top</span><span class="o">=</span><span class="n">baro_upper</span><span class="p">,</span> <span class="n">baro_bottom</span><span class="o">=</span><span class="n">baro_lower</span><span class="p">)</span>
</div>
<div class="viewcode-block" id="Zambretti"><a class="viewcode-back" href="../../api/pywws.Forecast.html#pywws.Forecast.Zambretti">[docs]</a><span class="k">def</span> <span class="nf">Zambretti</span><span class="p">(</span><span class="n">params</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">):</span>
    <span class="n">code</span> <span class="o">=</span> <span class="n">ZambrettiCode</span><span class="p">(</span><span class="n">params</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">Localisation</span><span class="o">.</span><span class="n">translation</span><span class="o">.</span><span class="n">ugettext</span><span class="p">(</span><span class="n">ZambrettiCore</span><span class="o">.</span><span class="n">ZambrettiText</span><span class="p">(</span><span class="n">code</span><span class="p">))</span>
</div>
<div class="viewcode-block" id="main"><a class="viewcode-back" href="../../api/pywws.Forecast.html#pywws.Forecast.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;h&quot;</span><span class="p">,</span> <span class="p">[</span><span class="s">&#39;help&#39;</span><span class="p">])</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># process options</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-h&#39;</span><span class="p">,</span> <span class="s">&#39;--help&#39;</span><span class="p">):</span>
            <span class="k">print</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">1</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&quot;Error: 1 argument required&quot;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="n">data_dir</span> <span class="o">=</span> <span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">params</span> <span class="o">=</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">params</span><span class="p">(</span><span class="n">data_dir</span><span class="p">)</span>
    <span class="n">Localisation</span><span class="o">.</span><span class="n">SetApplicationLanguage</span><span class="p">(</span><span class="n">params</span><span class="p">)</span>
    <span class="n">hourly_data</span> <span class="o">=</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">hourly_store</span><span class="p">(</span><span class="n">data_dir</span><span class="p">)</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">hourly_data</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">datetime</span><span class="o">.</span><span class="n">max</span><span class="p">)</span>
    <span class="k">print</span> <span class="s">&#39;Zambretti (current):&#39;</span><span class="p">,</span> <span class="n">Zambretti</span><span class="p">(</span><span class="n">params</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">[</span><span class="n">idx</span><span class="p">])</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">idx</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="n">utc</span><span class="p">)</span><span class="o">.</span><span class="n">astimezone</span><span class="p">(</span><span class="n">Local</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">idx</span><span class="o">.</span><span class="n">hour</span> <span class="o">&lt;</span> <span class="mi">8</span> <span class="ow">or</span> <span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">hour</span> <span class="o">==</span> <span class="mi">8</span> <span class="ow">and</span> <span class="n">idx</span><span class="o">.</span><span class="n">minute</span> <span class="o">&lt;</span> <span class="mi">30</span><span class="p">):</span>
        <span class="n">idx</span> <span class="o">-=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">24</span><span class="p">)</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">idx</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">hour</span><span class="o">=</span><span class="mi">9</span><span class="p">,</span> <span class="n">minute</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">second</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">hourly_data</span><span class="o">.</span><span class="n">nearest</span><span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">astimezone</span><span class="p">(</span><span class="n">utc</span><span class="p">)</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="bp">None</span><span class="p">))</span>
    <span class="n">lcl</span> <span class="o">=</span> <span class="n">idx</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="n">utc</span><span class="p">)</span><span class="o">.</span><span class="n">astimezone</span><span class="p">(</span><span class="n">Local</span><span class="p">)</span>
    <span class="k">print</span> <span class="s">&#39;Zambretti (at </span><span class="si">%s</span><span class="s">):&#39;</span> <span class="o">%</span> <span class="n">lcl</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s">&#39;%H:%M %Z&#39;</span><span class="p">),</span> <span class="n">Zambretti</span><span class="p">(</span>
        <span class="n">params</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">[</span><span class="n">idx</span><span class="p">])</span>
    <span class="k">return</span> <span class="mi">0</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>